﻿using System;
using KellermanSoftware.EncryptionCoreDemo.Models;
using KellermanSoftware.NetEncryptionLibrary;
using Microsoft.AspNetCore.Mvc;

namespace KellermanSoftware.EncryptionCoreDemo.Controllers
{
    public class EncryptionController : Controller
    {
        // GET: /<controller>/
        public IActionResult Index()
        {
            EncryptionViewModel model = new EncryptionViewModel();
            model.IV = "~#!?@%.^fA79&|;Z";
            model.Salt = "Salty12345";
            model.Key = "MyKey";
            model.Message = "This is a test";
            return View(model);
        }

        [HttpPost]
        public IActionResult Index(EncryptionViewModel model)
        {
            if (ModelState.IsValid)
            {
                Encryption encrypt;

                try
                {
                    encrypt = new Encryption(model.UserName, model.LicenseKey);
                }
                catch (Exception ex)
                {
                    model.DecryptedString = ex.Message;
                    ModelState.Clear();

                    return View(model);
                }

               
                encrypt.InitializationVector = model.IV;
                encrypt.Salt = model.Salt;
                HashProvider hashType;
                EncryptionProvider cryptType;

                // Do the actual encryption and decryption, based on the algorithm specified
                if (Enum.TryParse<HashProvider>(model.EncryptType.ToString(), out hashType))
                {
                    model.EncryptedString = encrypt.HashStringHex(hashType, model.Message);
                    model.DecryptedString = "One way hash, no decryption possible.";
                }
                else if (Enum.TryParse<EncryptionProvider>(model.EncryptType.ToString(), out cryptType))
                {
                    model.EncryptedString = encrypt.EncryptString(cryptType, model.Key, model.Message);
                    model.DecryptedString = encrypt.DecryptString(cryptType, model.Key, model.EncryptedString);
                }


                ModelState.Clear();
                return View(model);
            }
            return View();
        }
    }
}